searchNodes=[{"doc":"This module provides AMQP-related types.","ref":"AMQP.html","title":"AMQP","type":"module"},{"doc":"","ref":"AMQP.html#t:argument_type/0","title":"AMQP.argument_type/0","type":"type"},{"doc":"","ref":"AMQP.html#t:arguments/0","title":"AMQP.arguments/0","type":"type"},{"doc":"Provides access to configured connections and channels.","ref":"AMQP.Application.html","title":"AMQP.Application","type":"module"},{"doc":"Disables the progress report logging from Erlang library.The log outputs are very verbose and can contain credentials.This AMQP library recommends to disable unless you want the information.","ref":"AMQP.Application.html#disable_progress_report/0","title":"AMQP.Application.disable_progress_report/0","type":"function"},{"doc":"Enables the progress report logging from Erlang library.","ref":"AMQP.Application.html#enable_progress_report/0","title":"AMQP.Application.enable_progress_report/0","type":"function"},{"doc":"Provides an easy way to access an AMQP channel.AMQP.Application provides a wrapper on top of AMQP.Channel with .The channel will be monitored by AMQP's GenServer and it will automatically try to reopen when the channel is gone.UsageWhen you want to have a single channel in your app:config :amqp, connection: [url: &quot;amqp://guest:guest@localhost:15672&quot;], channel: []Then the channel will be open at the start of the application and you can access it via this function.iex&gt; {:ok, chan} = AMQP.Application.get_channel()You can also set up multiple channels with :channels key:config :amqp, connections: [ business_report: [url: &quot;amqp://host1&quot;], analytics: [url: &quot;amqp://host2&quot;] ], channels: [ bisiness_report: [connection: :business_report], analytics: [connection: :analytics] ]Then you can access each channel with its name.iex&gt; {:ok, conn1} = AMQP.Application.get_channel(:business_report) iex&gt; {:ok, conn2} = AMQP.Application.get_channel(:analytics)You can also have multiple channels for a single connection.config :amqp, connection: [], channels: [ consumer: [], producer: [] ]Configuration options:connection - The connection name configured with connection or connections (default :default):retry_interval - The retry interval in milliseconds when the channel is failed to open (default 5000)CaveatAlthough AMQP will reopen the named channel automatically when it is closed for some reasons, your application still needs to monitor the channel for a consumer process.Be aware the channel reopened doesn't automatically recover the subscription of your consumerHere is a sample GenServer module that monitors the channel and re-subscribe the channel.defmodule AppConsumer do use GenServer @channel :default @queue &quot;myqueue&quot; .... def handle_info(:subscribe, state) do case subscribe() do {:ok, chan} -&gt; {:noreply, Map.put(state, :channel, chan)} _ -&gt; {:noreply, state} end end def handle_info({:DOWN, _, :process, pid, reason}, %{channel: %{pid: pid}} = state) do send(self(), :subscribe) {:noreply, Map.put(state, :channel, nil)} end defp subscribe() do case AMQP.Application.get_channel(@channel) do {:ok, chan} -&gt; Process.monitor(chan.pid) AMQP.Basic.consume(@channel, @queue) _error -&gt; Process.send_after(self(), :subscribe, 1000) {:error, :retrying} end end end","ref":"AMQP.Application.html#get_channel/1","title":"AMQP.Application.get_channel/1","type":"function"},{"doc":"Provides an easy way to access an AMQP connection.The connection will be monitored by AMQP's GenServer and it will automatically try to reconnect when the connection is gone.UsageWhen you want to have a single connection in your app:config :amqp, connection: [ url: &quot;amqp://guest:guest@localhost:15672&quot; ]You can also use any options available on AMQP.Connection.open/2:config :amqp, connection: [ host: &quot;localhost&quot;, port: 15672 username: &quot;guest&quot;, password: &quot;guest&quot; ]Then the connection will be open at the start of the application and you can access via this function.iex&gt; {:ok, conn} = AMQP.Application.get_connection()By default, it tries to connect to your local RabbitMQ. You can simply pass the empty keyword list too:config :amqp, connection: [] # == [url: &quot;amqp://0.0.0.0&quot;]You can set up multiple connections wth :connections key:config :amqp, connections: [ business_report: [ url: &quot;amqp://host1&quot; ], analytics: [ url: &quot;amqp://host2&quot; ] ]Then you can access each connection with its name.iex&gt; {:ok, conn1} = AMQP.Application.get_connection(:business_report) iex&gt; {:ok, conn2} = AMQP.Application.get_connection(:analytics)The default name is :default so These two configurations are equivalent:config :amqp, connection: [] config :amqp, connections: [default: []]Configuration options:retry_interval - The retry interval in milliseconds when the connection is failed to open. (default 5000):url - AMQP URI for the connectionSee also AMQP.Connection.open/2 for all available options.","ref":"AMQP.Application.html#get_connection/1","title":"AMQP.Application.get_connection/1","type":"function"},{"doc":"Functions to publish, consume and acknowledge messages.","ref":"AMQP.Basic.html","title":"AMQP.Basic","type":"module"},{"doc":"Acknowledges one or more messages.Options:multiple - If set, all messages up to the one specified by delivery_tag are acknowledged (default false)","ref":"AMQP.Basic.html#ack/3","title":"AMQP.Basic.ack/3","type":"function"},{"doc":"Stops the given consumer from consuming.This method cancels a consumer. This does not affect already delivered messages, but it does mean the server will not send any more messages for that consumer. The client may receive an arbitrary number of messages in between sending the cancel method and receiving the reply.consumer_tag identifies the &quot;subscription&quot; to cancel, that is, the subscription of a consumer to a specific queue. The consumer tag is returned by consume/4.Options:nowait - If set, the cancel operation is asynchronous (default false)","ref":"AMQP.Basic.html#cancel/3","title":"AMQP.Basic.cancel/3","type":"function"},{"doc":"Removes the return handler, if it exists. Does nothing if there is no such handler.","ref":"AMQP.Basic.html#cancel_return/1","title":"AMQP.Basic.cancel_return/1","type":"function"},{"doc":"Registers a queue consumer process. The pid of the process can be set using the consumer_pid argument and defaults to the calling process.The consumer process will receive the following data structures:{:basic_deliver, payload, meta} - This is sent for each message consumed, where payload contains the message content and meta contains all the metadata set when sending with AMQP.Basic.publish/5 or additional info set by the broker{:basic_consume_ok, %{consumer_tag: consumer_tag}} - Sent when the consumer process is registered with Basic.consume. The caller receives the same information as the return of AMQP.Basic.consume/4{:basic_cancel, %{consumer_tag: consumer_tag, nowait: nowait}} - Sent by the broker when the consumer is unexpectedly cancelled (such as after a queue deletion){:basic_cancel_ok, %{consumer_tag: consumer_tag}} - Sent to the consumer process after a call to AMQP.Basic.cancel/3Options:consumer_tag - Specifies the consumer tag for this consumer (as a string). This tag is local to the given channel chan, so different channels can have consumers that use the same consumer tag. If the given consumer tag is &quot;&quot;, then the server autogenerates the tag (default &quot;&quot;):no_local - If set, the server won't send messages to the connection that published them (default false):no_ack - If set, the server will not expect message acks from the consumer and will consider every message that it believes was delivered to the consumer as acknowledged. Defaults to false, meaning that messages need to be acked explicitly through ack/3:exclusive - If set, requests exclusive consumer access, meaning that only this consumer can consume from the given queue. Note that the client cannot have exclusive access to a queue that already has consumers:nowait - If set, the consume operation is asynchronous (default false):arguments - A list of arguments to pass when consuming (of type AMQP.arguments/0). See the README for more information (default [])","ref":"AMQP.Basic.html#consume/4","title":"AMQP.Basic.consume/4","type":"function"},{"doc":"Polls a queue for an existing message.Returns the tuple {:empty, meta} if the queue is empty or the tuple {:ok, payload, meta} if at least one message exists in the queue. The returned meta map includes the entry :message_count with the current number of messages in the queue.Receiving messages by polling a queue is not as as efficient as subscribing a consumer to a queue, so consideration should be taken when receiving large volumes of messages.Options:no_ack - If set, the broker is told that the received will not send an acknoledgement of the message. Once the broker believes it has delivered the message, then it's free to assume that the consuming application has taken responsibility for it. In general, a lot of applications will not want these semantics, rather, they will want to explicitly acknowledge the receipt of a message (through ack/3) (default false, meaning explicit acks)","ref":"AMQP.Basic.html#get/3","title":"AMQP.Basic.get/3","type":"function"},{"doc":"Negative acknowledges of one or more messages.This is a RabbitMQ specific extension to AMQP 0.9.1. It is equivalent to reject/3, but allows rejecting multiple messages using the :multiple option.Options:multiple - If set, all messages up to the one specified by delivery_tag are considered as not acknowledged by the server (default false):requeue - If set, the message will be returned to the queue and redelivered to the next available consumer (default true)","ref":"AMQP.Basic.html#nack/3","title":"AMQP.Basic.nack/3","type":"function"},{"doc":"Publishes a message to an Exchange.This method publishes a message to a specific exchange. The message will be routed to queues as defined by the exchange configuration and distributed to any subscribers.The parameter exchange specifies the name of the exchange to publish to. If set to empty string, it publishes to the default exchange.The routing_key parameter specifies the routing key for the message.The payload parameter specifies the message content as a binary.In addition to the previous parameters, the following options can be used:Options:mandatory - If set, returns an error if the broker can't route the message to a queue (default false):immediate - If set, returns an error if the broker can't deliver the message to a consumer immediately (default false):content_type - MIME Content type:content_encoding - MIME Content encoding:headers - Message headers of type AMQP.arguments/0. Can be used with headers Exchanges:persistent - If set, uses persistent delivery mode. Messages marked as persistent that are delivered to durable queues will be logged to disk:correlation_id - application correlation identifier:priority - message priority, ranging from 0 to 9:reply_to - name of the reply queue:expiration - how long the message is valid (in milliseconds):message_id - message identifier:timestamp - timestamp associated with this message (epoch time):type - message type as a string:user_id - creating user ID. RabbitMQ will validate this against the active connection user:app_id - publishing application IDExamplesiex&gt; AMQP.Basic.publish chan, &quot;my_exchange&quot;, &quot;my_routing_key&quot;, &quot;Hello World!&quot;, persistent: true :ok","ref":"AMQP.Basic.html#publish/5","title":"AMQP.Basic.publish/5","type":"function"},{"doc":"Sets the message prefetch count or prefetch size (in bytes).This allows you to limit the number of unacknowledged messages.Options:prefetch_size - the prefetch size in bytes (default 0):prefetch_count - the prefetch count (default 0):global - If set, this applies to the entire Connection, otherwise it applies only to the given Channel (default false)","ref":"AMQP.Basic.html#qos/2","title":"AMQP.Basic.qos/2","type":"function"},{"doc":"Asks the server to redeliver all unacknowledged messages on a specified channel.Options:requeue - If set, the server will attempt to requeue the message, potentially delivering it to another subscriber. Otherwise it will be redelivered to the original recipient (default false)","ref":"AMQP.Basic.html#recover/2","title":"AMQP.Basic.recover/2","type":"function"},{"doc":"Rejects (and, optionally, requeues) a message.Options:requeue - If set, the message is requeued by the server, otherwise it's discarded (default true)","ref":"AMQP.Basic.html#reject/3","title":"AMQP.Basic.reject/3","type":"function"},{"doc":"Registers a handler to deal with returned messages.The registered process will receive {:basic_return, payload, meta} tuples.","ref":"AMQP.Basic.html#return/2","title":"AMQP.Basic.return/2","type":"function"},{"doc":"","ref":"AMQP.Basic.html#t:consumer_tag/0","title":"AMQP.Basic.consumer_tag/0","type":"type"},{"doc":"","ref":"AMQP.Basic.html#t:delivery_tag/0","title":"AMQP.Basic.delivery_tag/0","type":"type"},{"doc":"","ref":"AMQP.Basic.html#t:error/0","title":"AMQP.Basic.error/0","type":"type"},{"doc":"","ref":"AMQP.Basic.html#t:exchange/0","title":"AMQP.Basic.exchange/0","type":"type"},{"doc":"","ref":"AMQP.Basic.html#t:payload/0","title":"AMQP.Basic.payload/0","type":"type"},{"doc":"","ref":"AMQP.Basic.html#t:queue/0","title":"AMQP.Basic.queue/0","type":"type"},{"doc":"","ref":"AMQP.Basic.html#t:routing_key/0","title":"AMQP.Basic.routing_key/0","type":"type"},{"doc":"Functions to operate on Channels.","ref":"AMQP.Channel.html","title":"AMQP.Channel","type":"module"},{"doc":"Closes an open Channel.","ref":"AMQP.Channel.html#close/1","title":"AMQP.Channel.close/1","type":"function"},{"doc":"Opens a new Channel in a previously opened Connection.Allows optionally to pass a custom_consumer/0 to start a custom consumer implementation. The consumer must implement the :amqp_gen_consumer behavior from :amqp_client. See :amqp_connection.open_channel/2 for more details and AMQP.DirectConsumer for an example of a custom consumer.","ref":"AMQP.Channel.html#open/2","title":"AMQP.Channel.open/2","type":"function"},{"doc":"","ref":"AMQP.Channel.html#t:custom_consumer/0","title":"AMQP.Channel.custom_consumer/0","type":"type"},{"doc":"","ref":"AMQP.Channel.html#t:t/0","title":"AMQP.Channel.t/0","type":"type"},{"doc":"Functions that work with publisher confirms (RabbitMQ extension to AMQP 0.9.1).","ref":"AMQP.Confirm.html","title":"AMQP.Confirm","type":"module"},{"doc":"On channel with confirm activated, return the next message sequence number.To use in combination with register_handler/2","ref":"AMQP.Confirm.html#next_publish_seqno/1","title":"AMQP.Confirm.next_publish_seqno/1","type":"function"},{"doc":"Register a handler for confirms on channel.The handler will receive either:{:basic_ack, seqno, multiple}{:basic_nack, seqno, multiple}The seqno (delivery_tag) is an integer, the sequence number of the message.multiple is a boolean, when true means multiple messages confirm, up to seqno.See https://www.rabbitmq.com/confirms.html","ref":"AMQP.Confirm.html#register_handler/2","title":"AMQP.Confirm.register_handler/2","type":"function"},{"doc":"Activates publishing confirmations on the channel.","ref":"AMQP.Confirm.html#select/1","title":"AMQP.Confirm.select/1","type":"function"},{"doc":"Remove the return handler.It does nothing if there is no such handler.","ref":"AMQP.Confirm.html#unregister_handler/1","title":"AMQP.Confirm.unregister_handler/1","type":"function"},{"doc":"Wait until all messages published since the last call have been either ack'd or nack'd by the broker.","ref":"AMQP.Confirm.html#wait_for_confirms/1","title":"AMQP.Confirm.wait_for_confirms/1","type":"function"},{"doc":"Wait until all messages published since the last call have been either ack'd or nack'd by the broker, or until timeout elapses.","ref":"AMQP.Confirm.html#wait_for_confirms/2","title":"AMQP.Confirm.wait_for_confirms/2","type":"function"},{"doc":"Wait until all messages published since the last call have been either ack'd or nack'd by the broker, or until timeout elapses.If any of the messages were nack'd, the calling process dies.","ref":"AMQP.Confirm.html#wait_for_confirms_or_die/1","title":"AMQP.Confirm.wait_for_confirms_or_die/1","type":"function"},{"doc":"","ref":"AMQP.Confirm.html#wait_for_confirms_or_die/2","title":"AMQP.Confirm.wait_for_confirms_or_die/2","type":"function"},{"doc":"Functions to operate on Connections.","ref":"AMQP.Connection.html","title":"AMQP.Connection","type":"module"},{"doc":"Closes an open Connection.","ref":"AMQP.Connection.html#close/1","title":"AMQP.Connection.close/1","type":"function"},{"doc":"Opens a new connection.Behaves like open/2 but takes only either AMQP URI or options.Examplesiex&gt; options = [host: &quot;localhost&quot;, port: 5672, virtual_host: &quot;/&quot;, username: &quot;guest&quot;, password: &quot;guest&quot;] iex&gt; AMQP.Connection.open(options) {:ok, %AMQP.Connection{}} iex&gt; AMQP.Connection.open(&quot;amqp://guest:guest@localhost&quot;) {:ok, %AMQP.Connection{}}","ref":"AMQP.Connection.html#open/1","title":"AMQP.Connection.open/1","type":"function"},{"doc":"Opens an new Connection to an AMQP broker.The connections created by this module are supervised under amqp_client's supervision tree. Please note that connections do not get restarted automatically by the supervision tree in case of a failure. If you need robust connections and channels, use monitors on the returned connection PID.Options:username - The name of a user registered with the broker (default &quot;guest&quot;):password - The password of user (default to &quot;guest&quot;):virtual_host - The name of a virtual host in the broker (defaults &quot;/&quot;):host - The hostname of the broker (default &quot;localhost&quot;):port - The port the broker is listening on (default 5672):channel_max - The channel_max handshake parameter (default 0):frame_max - The frame_max handshake parameter (defaults 0):heartbeat - The hearbeat interval in seconds (defaults 10):connection_timeout - The connection timeout in milliseconds (efaults 50000):ssl_options - Enable SSL by setting the location to cert files (default :none):client_properties - A list of extra client properties to be sent to the server (default []):socket_options - Extra socket options. These are appended to the default options. See http://www.erlang.org/doc/man/inet.html#setopts-2 and http://www.erlang.org/doc/man/gen_tcp.html#connect-4 for descriptions of the available options:auth_mechanisms - A list of authentication of SASL authentication mechanisms to use. See https://www.rabbitmq.com/access-control.html#mechanisms and https://github.com/rabbitmq/rabbitmq-auth-mechanism-ssl for descriptions of the available options:name - A human-readable string that will be displayed in the management UI. Connection names do not have to be unique and cannot be used as connection identifiers (default :undefined)Examplesiex&gt; options = [host: &quot;localhost&quot;, port: 5672, virtual_host: &quot;/&quot;, username: &quot;guest&quot;, password: &quot;guest&quot;, name: &quot;my-conn&quot;] iex&gt; AMQP.Connection.open(options) {:ok, %AMQP.Connection{}} iex&gt; AMQP.Connection.open(&quot;amqp://guest:guest@localhost&quot;, port: 5673) {:ok, %AMQP.Connection{}}Enabling SSLTo enable SSL, supply the following in the ssl_options field::cacertfile - Specifies the certificates of the root Certificate Authorities that we wish to implicitly trust:certfile - The client's own certificate in PEM format:keyfile - The client's private key in PEM formatHere is an example:iex&gt; AMQP.Connection.open( port: 5671, ssl_options: [ cacertfile: &#39;/path/to/testca/cacert.pem&#39;, certfile: &#39;/path/to/client/cert.pem&#39;, keyfile: &#39;/path/to/client/key.pem&#39;, # only necessary with intermediate CAs # depth: 2, verify: :verify_peer, fail_if_no_peer_cert: true ] )Backward compatibility for connection nameRabbitMQ supports user-specified connection names since version 3.6.2.Previously AMQP took a connection name as a separate parameter on open/2 and open/3 and it is still supported in this version.iex&gt; options = [host: &quot;localhost&quot;, port: 5672, virtual_host: &quot;/&quot;, username: &quot;guest&quot;, password: &quot;guest&quot;] iex&gt; AMQP.Connection.open(options, :undefined) {:ok, %AMQP.Connection{}} iex&gt; AMQP.Connection.open(&quot;amqp://guest:guest@localhost&quot;, &quot;my-connection&quot;) {:ok, %AMQP.Connection{}} iex&gt; AMQP.Connection.open(&quot;amqp://guest:guest@localhost&quot;, &quot;my-connection&quot;, options) {:ok, %AMQP.Connection{}}However the connection name parameter is now deprecated and might not be supported in the future versions.You are recommended to pass it with :name option instead:iex&gt; AMQP.Connection.open(&quot;amqp://guest:guest@localhost&quot;, name: &quot;my-connection&quot;) {:ok, %AMQP.Connection{}}","ref":"AMQP.Connection.html#open/2","title":"AMQP.Connection.open/2","type":"function"},{"doc":"","ref":"AMQP.Connection.html#t:t/0","title":"AMQP.Connection.t/0","type":"type"},{"doc":"AMQP.DirectConsumer is an example custom consumer. It's argument is a pid of a process which the channel is meant to forward the messages to.Usageiex&gt; AMQP.Channel.open(conn, {AMQP.DirectConsumer, self()})This will forward all the messages from the channel to the calling process.This is an Elixir reimplementation of :amqp_direct_consumer. (https://github.com/rabbitmq/rabbitmq-erlang-client/blob/master/src/amqp_direct_consumer.erl)For more information see: https://www.rabbitmq.com/erlang-client-user-guide.html#consumers-imlementationCaveatYou are recommended to use the default consumerAMQP 2.0 comes with an improved version of the default consumer(AMQP.SelectiveConsumer). There is not an obvious reason using DirectConsumer after the version 2.0. We highly recommend you to use the default consumer which lets you decouple the consumer concern from the channel. If you still want to keep using DirectConsumer, keep reading the caveat below.Close the channel explicitlyBy default, the DirectConsumer detects the user consumer down then...DirectConsumer returns :error in handle_info which results the process to exit.The channel supervisor will detect the DirectConsumer shutdown but the restart will be failing as the user consumer is still down.It ends up the channel process to shut down.However this is an abnormal shutdown and can cause an unintended race condition.To avoid it, make sure to close the channel explicitly and shut down your consumer with a :normal signal.Ignore the user consumer shutdownDirectConsumer follows the Erlang version and ignores only :normal signals for the user consumer exit.You might want to also ignore :shutdown signals as it can also be called before the channel is closed.You can set the additional reasons to ignore with the following options:iex&gt; opts = [ignore_consumer_down: [:normal, :shutdown]] iex&gt; AMQP.Channel.open(conn, {AMQP.DirectConsumer, {self(), opts}})You can also ignore the user consumer down completely by setting true to the value:iex&gt; opts = [ignore_consumer_down: true] iex&gt; AMQP.Channel.open(conn, {AMQP.DirectConsumer, {self(), opts}})","ref":"AMQP.DirectConsumer.html","title":"AMQP.DirectConsumer","type":"module"},{"doc":"Functions to operate on Exchanges.","ref":"AMQP.Exchange.html","title":"AMQP.Exchange","type":"module"},{"doc":"Binds an Exchange to another Exchange using the exchange.bind AMQP method (a RabbitMQ-specific extension).Options:routing_key - the routing key to use for the binding (default &quot;&quot;):nowait - If set, the bind operation is asynchronous (default false):arguments - A list of arguments to pass when binding (of type AMQP.arguments/0). See the README for more information (default to [])","ref":"AMQP.Exchange.html#bind/4","title":"AMQP.Exchange.bind/4","type":"function"},{"doc":"Declares an Exchange. The default Exchange type is direct.AMQP 0-9-1 brokers provide four pre-declared exchanges::direct exchange: (empty string) or amq.direct:fanout exchange: amq.fanout:topic exchange: amq.topic:headers exchange: amq.match (and amq.headers in RabbitMQ)Besides the exchange name and type, the following options can be used:Options:durable - If set, keeps the Exchange between restarts of the broker:auto_delete - If set, deletes the Exchange once all queues unbind from it:passive - If set, returns an error if the Exchange does not already exist:internal - If set, the exchange may not be used directly by publishers, but only when bound to other exchanges. Internal exchanges are used to construct wiring that is not visible to applications:nowait - If set, the declare operation is asynchronous (default false):arguments - A list of arguments to pass when declaring (of type AMQP.arguments/0). See the README for more information (default to [])","ref":"AMQP.Exchange.html#declare/4","title":"AMQP.Exchange.declare/4","type":"function"},{"doc":"Deletes an Exchange by name. When an Exchange is deleted all bindings to it are also deleted.Options:if_unused - If set, the server will only delete the exchange if it has no queue bindings:nowait - If set, the delete operation is asynchronous (default false)","ref":"AMQP.Exchange.html#delete/3","title":"AMQP.Exchange.delete/3","type":"function"},{"doc":"Convenience function to declare an Exchange of type direct.OptionsThis function takes the same options as declare/4.","ref":"AMQP.Exchange.html#direct/3","title":"AMQP.Exchange.direct/3","type":"function"},{"doc":"Convenience function to declare an Exchange of type fanout.OptionsThis function takes the same options as declare/4.","ref":"AMQP.Exchange.html#fanout/3","title":"AMQP.Exchange.fanout/3","type":"function"},{"doc":"Convenience function to declare an Exchange of type topic.OptionsThis function takes the same options as declare/4.","ref":"AMQP.Exchange.html#topic/3","title":"AMQP.Exchange.topic/3","type":"function"},{"doc":"Unbinds an Exchange from another Exchange or a Queue using the exchange.unbind AMQP method (a RabbitMQ-specific extension).Options:routing_key - the routing key to use for the binding (default &quot;&quot;):nowait - If set, the declare operation is asynchronous (default false):arguments - A list of arguments to pass when declaring (of type AMQP.arguments/0). See the README for more information (defaults [])","ref":"AMQP.Exchange.html#unbind/4","title":"AMQP.Exchange.unbind/4","type":"function"},{"doc":"Functions to operate on Queues.","ref":"AMQP.Queue.html","title":"AMQP.Queue","type":"module"},{"doc":"Binds a Queue to an Exchange.Options:routing_key - The routing key used to bind the queue to the exchange (default &quot;&quot;):nowait - If true, the binding is not synchronous (default false):arguments - A list of arguments to pass when binding (of type AMQP.arguments/0). See the README for more information (default [])","ref":"AMQP.Queue.html#bind/4","title":"AMQP.Queue.bind/4","type":"function"},{"doc":"Returns a number of active consumers on the queue.","ref":"AMQP.Queue.html#consumer_count/2","title":"AMQP.Queue.consumer_count/2","type":"function"},{"doc":"Declares a queue. The optional queue parameter is used to set the name. If set to an empty string (default), the server will assign a name.Besides the queue name, the following options can be used:Options:durable - If set, keeps the Queue between restarts of the broker (default false):auto_delete - If set, deletes the Queue once all subscribers disconnect (default to false):exclusive - If set, only one subscriber can consume from the Queue (default false):passive - If set, raises an error unless the queue already exists (default false):nowait - If set, the declare operation is asynchronous (default false):arguments - A list of arguments to pass when declaring (of type AMQP.arguments/0). See the README for more information (default [])","ref":"AMQP.Queue.html#declare/3","title":"AMQP.Queue.declare/3","type":"function"},{"doc":"Deletes a Queue by name.Options:if_unused - If set, the server will only delete the queue if it has no consumers. If the queue has consumers, it's not deleted and an error is returned:if_empty - If set, the server will only delete the queue if it has no messages:nowait - If set, the delete operation is asynchronous","ref":"AMQP.Queue.html#delete/3","title":"AMQP.Queue.delete/3","type":"function"},{"doc":"Returns true if queue is empty (has no messages ready), false otherwise.","ref":"AMQP.Queue.html#empty?/2","title":"AMQP.Queue.empty?/2","type":"function"},{"doc":"Returns the number of messages that are ready for delivery (e.g. not pending acknowledgements) in the queue.","ref":"AMQP.Queue.html#message_count/2","title":"AMQP.Queue.message_count/2","type":"function"},{"doc":"Discards all messages in the Queue.","ref":"AMQP.Queue.html#purge/2","title":"AMQP.Queue.purge/2","type":"function"},{"doc":"Returns the message count and consumer count for the given queue. Uses declare/3 with the :passive option set.","ref":"AMQP.Queue.html#status/2","title":"AMQP.Queue.status/2","type":"function"},{"doc":"Convenience to consume messages from a Queue.The handler function must have arity 2 and will receive as arguments a binary with the message payload and a Map with the message properties.The consumed message will be acknowledged after executing the handler function.If an exception is raised by the handler function, the message is rejected.This convenience function will spawn a process and register it using AMQP.Basic.consume/4.","ref":"AMQP.Queue.html#subscribe/4","title":"AMQP.Queue.subscribe/4","type":"function"},{"doc":"Unbinds a Queue from an Exchange.Options:routing_key - The routing queue for removing the binding (default &quot;&quot;):arguments - A list of arguments to pass when unbinding (of type AMQP.arguments/0). See the README for more information (defaults [])","ref":"AMQP.Queue.html#unbind/4","title":"AMQP.Queue.unbind/4","type":"function"},{"doc":"Stops the consumer identified by consumer_tag from consuming.Internally just calls AMQP.Basic.cancel/2.","ref":"AMQP.Queue.html#unsubscribe/2","title":"AMQP.Queue.unsubscribe/2","type":"function"},{"doc":"This is an Elixir reimplementation of :amqp_selective_consumer - source.The module is used by default when you open a channel via AMQP.Channel.open/2 and allows you to end consumer processes via AMQP.Basic.consume/4 and receive messages from a queue.Usually you don't have to pay attention to this module as the interaction would be made through AMQP.Channel.open/2, AMQP.Basic.consume/4, AMQP.Basic.return/2, AMQP.Confirm.register_handler/2 etc.","ref":"AMQP.SelectiveConsumer.html","title":"AMQP.SelectiveConsumer","type":"module"},{"doc":"Ported from :amqp_selective_consumer.register_default_consumer/2.This function registers a default consumer with the channel.A default consumer is used when a subscription is made via amqp_channel:call(ChannelPid, #'basic.consume'{}) (rather than {@module}:subscribe/3) and hence there is no consumer pid registered with the consumer tag. In this case, the relevant deliveries will be sent to the default consumer.","ref":"AMQP.SelectiveConsumer.html#register_default_consumer/2","title":"AMQP.SelectiveConsumer.register_default_consumer/2","type":"function"},{"doc":"","ref":"AMQP.SelectiveConsumer.html#t:t/0","title":"AMQP.SelectiveConsumer.t/0","type":"type"},{"doc":"Raised when the connection is closed or blocked.","ref":"AMQP.BasicError.html","title":"AMQP.BasicError","type":"exception"},{"doc":"AMQP Simple Elixir wrapper for the Erlang RabbitMQ client.The API is based on Langohr, a Clojure client for RabbitMQ.","ref":"readme.html","title":"AMQP","type":"extras"},{"doc":"To upgrade from the old version, please read our upgrade guides:0.x to 1.x1.x to 2.x","ref":"readme.html#upgrading-guides","title":"AMQP - Upgrading guides","type":"extras"},{"doc":"Add AMQP as a dependency in your mix.exs file.def deps do [ {:amqp, &quot;~&gt; 2.1&quot;} ] endElixir will start amqp automatically with this if you use Elixir 1.6+.If that's not the case (use Application.started_applications/0 to check), try adding :amqp to applications or extra_applications in your mix.exs. Or call Application.ensure_started(:amqp) at the start.After you are done, run mix deps.get in your shell to fetch and compile AMQP. Start an interactive Elixir shell with iex -S mix.iex&gt; {:ok, conn} = AMQP.Connection.open() # {:ok, %AMQP.Connection{pid: #PID&lt;0.165.0&gt;}} iex&gt; {:ok, chan} = AMQP.Channel.open(conn) # {:ok, %AMQP.Channel{conn: %AMQP.Connection{pid: #PID&lt;0.165.0&gt;}, pid: #PID&lt;0.177.0&gt;} iex&gt; AMQP.Queue.declare(chan, &quot;test_queue&quot;) # {:ok, %{consumer_count: 0, message_count: 0, queue: &quot;test_queue&quot;}} iex&gt; AMQP.Exchange.declare(chan, &quot;test_exchange&quot;) # :ok iex&gt; AMQP.Queue.bind(chan, &quot;test_queue&quot;, &quot;test_exchange&quot;) # :ok iex&gt; AMQP.Basic.publish(chan, &quot;test_exchange&quot;, &quot;&quot;, &quot;Hello, World!&quot;) # :ok iex&gt; {:ok, payload, meta} = AMQP.Basic.get(chan, &quot;test_queue&quot;) iex&gt; payload # &quot;Hello, World!&quot; iex&gt; AMQP.Queue.subscribe(chan, &quot;test_queue&quot;, fn payload, _meta -&gt; IO.puts(&quot;Received: \#{payload}&quot;) end) # {:ok, &quot;amq.ctag-5L8U-n0HU5doEsNTQpaXWg&quot;} iex&gt; AMQP.Basic.publish(chan, &quot;test_exchange&quot;, &quot;&quot;, &quot;Hello, World!&quot;) # :ok # Received: Hello, World!Setup a consumer GenServerdefmodule Consumer do use GenServer use AMQP def start_link do GenServer.start_link(__MODULE__, [], []) end @exchange &quot;gen_server_test_exchange&quot; @queue &quot;gen_server_test_queue&quot; @queue_error &quot;\#{@queue}_error&quot; def init(_opts) do {:ok, conn} = Connection.open(&quot;amqp://guest:guest@localhost&quot;) {:ok, chan} = Channel.open(conn) setup_queue(chan) # Limit unacknowledged messages to 10 :ok = Basic.qos(chan, prefetch_count: 10) # Register the GenServer process as a consumer {:ok, _consumer_tag} = Basic.consume(chan, @queue) {:ok, chan} end # Confirmation sent by the broker after registering this process as a consumer def handle_info({:basic_consume_ok, %{consumer_tag: consumer_tag}}, chan) do {:noreply, chan} end # Sent by the broker when the consumer is unexpectedly cancelled (such as after a queue deletion) def handle_info({:basic_cancel, %{consumer_tag: consumer_tag}}, chan) do {:stop, :normal, chan} end # Confirmation sent by the broker to the consumer process after a Basic.cancel def handle_info({:basic_cancel_ok, %{consumer_tag: consumer_tag}}, chan) do {:noreply, chan} end def handle_info({:basic_deliver, payload, %{delivery_tag: tag, redelivered: redelivered}}, chan) do # You might want to run payload consumption in separate Tasks in production consume(chan, tag, redelivered, payload) {:noreply, chan} end defp setup_queue(chan) do {:ok, _} = Queue.declare(chan, @queue_error, durable: true) # Messages that cannot be delivered to any consumer in the main queue will be routed to the error queue {:ok, _} = Queue.declare(chan, @queue, durable: true, arguments: [ {&quot;x-dead-letter-exchange&quot;, :longstr, &quot;&quot;}, {&quot;x-dead-letter-routing-key&quot;, :longstr, @queue_error} ] ) :ok = Exchange.fanout(chan, @exchange, durable: true) :ok = Queue.bind(chan, @queue, @exchange) end defp consume(channel, tag, redelivered, payload) do number = String.to_integer(payload) if number &lt;= 10 do :ok = Basic.ack channel, tag IO.puts &quot;Consumed a \#{number}.&quot; else :ok = Basic.reject channel, tag, requeue: false IO.puts &quot;\#{number} is too big and was rejected.&quot; end rescue # Requeue unless it&#39;s a redelivered message. # This means we will retry consuming a message once in case of exception # before we give up and have it moved to the error queue # # You might also want to catch :exit signal in production code. # Make sure you call ack, nack or reject otherwise comsumer will stop # receiving messages. exception -&gt; :ok = Basic.reject channel, tag, requeue: not redelivered IO.puts &quot;Error converting \#{payload} to integer&quot; end endiex&gt; Consumer.start_link {:ok, #PID&lt;0.261.0&gt;} iex&gt; {:ok, conn} = AMQP.Connection.open {:ok, %AMQP.Connection{pid: #PID&lt;0.165.0&gt;}} iex&gt; {:ok, chan} = AMQP.Channel.open(conn) {:ok, %AMQP.Channel{conn: %AMQP.Connection{pid: #PID&lt;0.165.0&gt;}, pid: #PID&lt;0.177.0&gt;} iex&gt; AMQP.Basic.publish chan, &quot;gen_server_test_exchange&quot;, &quot;&quot;, &quot;5&quot; :ok Consumed a 5. iex&gt; AMQP.Basic.publish chan, &quot;gen_server_test_exchange&quot;, &quot;&quot;, &quot;42&quot; :ok 42 is too big and was rejected. iex&gt; AMQP.Basic.publish chan, &quot;gen_server_test_exchange&quot;, &quot;&quot;, &quot;Hello, World!&quot; :ok Error converting Hello, World! to integer Error converting Hello, World! to integerConfigurationErlang library's progress reportThis library uses an official Erlang RabbitMQ client library internally and we found its logging is too verbose.These are called progress reports by the Erlang library and you would see a lot of entries with info log level if you use 1.x version.AMQP disables that by default from version 2.0. If you want to see more detailed logs, you can enable it by adding the following line on your config.config :amqp, enable_progress_report: trueConnections and channelsYou can define a connection and channel in your config and AMQP will automatically...Open the connection and channel at the start of the applicationAutomatically try to reconnect if they are disconnectedconfig :amqp, connections: [ myconn: [url: &quot;amqp://guest:guest@myhost:12345&quot;], ], channels: [ mychan: [connection: :myconn] ]You can access the connection/channel via AMQP.Application.iex&gt; {:ok, chan} = AMQP.Application.get_channel(:mychan) iex&gt; :ok = AMQP.Basic.publish(chan, &quot;&quot;, &quot;&quot;, &quot;Hello&quot;)When a channel is down and reconnected, you have to make sure your consumer subscribes to a channel again.See the documentation for AMQP.Application.get_connection/1 and AMQP.Application.get_channel/1 for more details.Types of arguments and headersThe parameter arguments in Queue.declare, Exchange.declare, Basic.consume and the parameter headers in Basic.publish are a list of tuples in the form {name, type, value}, where name is a binary containing the argument/header name, type is an atom describing the AMQP field type and value a term compatible with the AMQP field type.The valid AMQP field types are::longstr | :signedint | :decimal | :timestamp | :table | :byte | :double | :float | :long | :short | :bool | :binary | :void | :arrayValid argument names in Queue.declare include:&quot;x-expires&quot;&quot;x-message-ttl&quot;&quot;x-dead-letter-routing-key&quot;&quot;x-dead-letter-exchange&quot;&quot;x-max-length&quot;&quot;x-max-length-bytes&quot;Valid argument names in Basic.consume include:&quot;x-priority&quot;&quot;x-cancel-on-ha-failover&quot;Valid argument names in Exchange.declare include:&quot;alternate-exchange&quot;","ref":"readme.html#usage","title":"AMQP - Usage","type":"extras"},{"doc":"Consumer stops receiving messagesIt usually happens when your code doesn't send acknowledgement(ack, nack or reject) after receiving a message.If you use GenServer for your consumer, try storing the number of messages the server is currently processing to the GenServer state.If the number equals prefetch_count, those messages were left without acknowledgements and that's why the consumer has stopped receiving more messages.Also review the following points:when an exception was raised how it would be handledwhen :exit signal was thrown how it would be handledwhen a message processing took long time what could happenAlso make sure that the consumer monitors the channel pid. When the channel is gone, you have to reopen it and subscribe to a new channel again.The version compatibilityCheck out this article to find out the compatibility with Elixir, OTP and RabbitMQ.HeartbeatsIn case the connection is dropped automatically, consider enabling heartbeats.You can set heartbeat option when you open a connection.For more details, read this articleLog related to amqp supervisors are too verboseTry the following configuration.config :logger, handle_otp_reports: falseLager conflicts with Elixir loggerLager is used by rabbit_common and it is not Elixir's best friend yet. You need a workaround.In mix.exs, you have to load :lager before :logger. extra_applications: [:lager, :logger, :amqp]Here is a sample configuration to silent rabbit_common logging.config :lager, error_logger_redirect: false, handlers: [level: :critical]Check out Lager and RabbitMQ documentation for more information.Compile error on ranch_proxy_protocol with OTP 21Update amqp to 1.1.0 or a greater version.Does the library support AMQP 1.0?Currently the library doesn't support AMQP 1.0 and there is no plan to do so at the moment. Our main aim here (at least for now) is to provide a thin wrapper around amqp_client for Elixir programmers.","ref":"readme.html#troubleshooting-faq","title":"AMQP - Troubleshooting / FAQ","type":"extras"},{"doc":"Copyright (c) 2014 Paulo AlmeidaThis library is MIT licensed. See the LICENSE for details.","ref":"readme.html#copyright-and-license","title":"AMQP - Copyright and License","type":"extras"}]